Home | All Classes | Main Classes | Annotated | Grouped Classes | Functions |

# TQNPWidget Class Reference

The TQNPWidget class provides a TQWidget that is a web browser plugin window. More...

This class is part of the TQt Netscape Extension.

`#include <ntqnp.h>`

Inherits TQWidget.

List of all member functions.

## Public Members

- TQNPWidget ()
- ~TQNPWidget ()
- virtual void enterInstance ()
- virtual void leaveInstance ()
- TQNPInstance * instance ()

## Detailed Description

This class is defined in the TQt Netscape Extension, which can be found in the `qt/extensions` directory. It is not included in the main TQt API.

The TQNPWidget class provides a TQWidget that is a web browser plugin window.

Derive from TQNPWidget to create a widget that can be used as a web browser plugin window, or create one and add child widgets. Instances of TQNPWidget may only be created when TQNPInstance::newWindow() is called by the browser.

A common way to develop a plugin widget is to develop it as a stand-alone application window, then make it a child of a plugin widget to use it as a browser plugin. The technique is:

    class MyPluginWindow : public TQNPWidget
    {
        TQWidget* child;
    public:
        MyPluginWindow()
        {
            // Some widget that is normally used as a top-level widget
            child = new MyIndependentlyDevelopedWidget();

            // Use the background color of the web page
            child->setBackgroundColor( backgroundColor() );

            // Fill the plugin widget
            child->setGeometry( 0, 0, width(), height() );
        }

        void resizeEvent(TQResizeEvent*)
        {
            // Fill the plugin widget
            child->resize(size());
        }
    };

The default implementation is an empty window.

## Member Function Documentation

### TQNPWidget::TQNPWidget ()

Creates a TQNPWidget.

### TQNPWidget::~TQNPWidget ()

Destroys the window. This will be called by the plugin binding code when the window is no longer required. The web browser will delete windows when they leave the page. The bindings will change the TQWidget::winId() of the window when the window is resized, but this should not affect normal widget behavior.

### void TQNPWidget::enterInstance ()`[virtual]`

Called when the mouse enters the plugin window. Does nothing by default.

Example: grapher/grapher.cpp.

### TQNPInstance * TQNPWidget::instance ()

Returns the instance for which this widget is the plugin window.

### void TQNPWidget::leaveInstance ()`[virtual]`

Called when the mouse leaves the plugin window. Does nothing by default.

Example: grapher/grapher.cpp.

This file is part of the TQt toolkit. Copyright © 1995-2007 Trolltech. All Rights Reserved.